#include <stdio.h>
#include <assert.h>
#include "csv.h"
#include "api.h"
#include <string.h>


#define FILE_READ_BUFFER_SIZE 2048

// Get the API version information
const char* api_version() {
    return "UOC PP 20211";
}

// Load data from a CSV file. If reset is true, remove previous data
tApiError api_loadData(tApiData* data, const char* filename, bool reset) {
    tApiError error;
    FILE *fin;    
    char buffer[FILE_READ_BUFFER_SIZE];
    tCSVEntry entry;
    
    // Check input data
    assert( data != NULL );
    assert(filename != NULL);
    
    // Reset current data    
    if (reset) {
        // Remove previous information
        error = api_freeData(data);
        if (error != E_SUCCESS) {
            return error;
        }
        
        // Initialize the data
        error = api_initData(data);
        if (error != E_SUCCESS) {
            return error;
        }
    }

    // Open the input file
    fin = fopen(filename, "r");
    if (fin == NULL) {
        return E_FILE_NOT_FOUND;
    }
    
    // Read file line by line
    while (fgets(buffer, FILE_READ_BUFFER_SIZE, fin)) {
        // Remove new line character     
        buffer[strcspn(buffer, "\n\r")] = '\0';
        
        csv_initEntry(&entry);
        csv_parseEntry(&entry, buffer, NULL);
        // Add this new entry to the api Data
        error = api_addDataEntry(data, entry);
        if (error != E_SUCCESS) {
            return error;
        }
    }
    
    fclose(fin);
    
    return E_SUCCESS;
}

// Add a new entry
tApiError api_addDataEntry(tApiData* data, tCSVEntry entry) { 
    
    //////////////////////////////////
    // Ex PR1 2
    /////////////////////////////////
    return E_NOT_IMPLEMENTED;
}

// Free all used memory
tApiError api_freeData(tApiData* data) {
    //////////////////////////////////
    // Ex PR1 2: 
    /////////////////////////////////
    return E_NOT_IMPLEMENTED;
}

// Initialize the data structure
tApiError api_initData(tApiData* data) {
        
    //////////////////////////////////
    // Ex PR1 2: 
    /////////////////////////////////
    return E_NOT_IMPLEMENTED;
}

// Get person data
tApiError api_findPerson(tApiData* data, const char* document, tCSVEntry* person) {
    //////////////////////////////////
    // Ex PR1 3
    /////////////////////////////////
    return E_NOT_IMPLEMENTED;
}

// Get all geolocation data for a given person
tApiError api_getPersonGeolocation(tApiData* data, const char* document, tCSVData* geodata) {
    //////////////////////////////////
    // Ex PR1 3
    /////////////////////////////////    
    return E_NOT_IMPLEMENTED;
}

// Remove a person
tApiError api_removePerson(tApiData* data, const char* document) {
    //////////////////////////////////
    // Ex PR1 3
    /////////////////////////////////     
    return E_NOT_IMPLEMENTED;
}
